function strCode(str) {  //获取字符串的字节数
    var count = 0;  //初始化字节数递加变量并获取字符串参数的字符个数
    var cn = [8211, 8212, 8216, 8217, 8220, 8221, 8230, 12289, 12290, 12296, 12297, 12298, 12299, 12300, 12301, 12302, 12303, 12304, 12305, 12308, 12309, 65281, 65288, 65289, 65292, 65294, 65306, 65307, 65311]
    var half = [32, 33, 34, 35, 36, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 58, 59, 60, 61, 62, 63, 64, 91, 92, 93, 94, 95, 96, 123, 124, 125, 126,105,108,8211]
    if (str) {  //如果存在字符串，则执行
        len = str.length; 
        for (var i = 0; i < len; i++) {  //遍历字符串，枚举每个字符
          let charCode = str.charCodeAt(i)
            if (charCode>=65 && charCode<=90) {
              count += 1.5;  //大写
            } else if (half.includes(charCode)) {
              count +=0.45
            } else if (cn.includes(charCode)) {
              count +=0.8
            }else if (charCode > 255) {  //字符编码大于255，说明是双字节字符(即是中文)
                count += 2;  //则累加2个
            }else{
                count++;  //否则递加一次
            }
        }
        return count;  //返回字节数
    } else {
        return 0;  //如果参数为空，则返回0个
    }
}

function getSplitLine() {
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let readerFrame = Application.sharedInstance().studyController(this.window).readerController.view.frame
    let hidden = Application.sharedInstance().studyController(this.window).readerController.view.hidden//true代表脑图全屏
    let rightMode = Application.sharedInstance().studyController(this.window).rightMapMode
    let fullWindow = readerFrame.width == studyFrame.width
    if (hidden || fullWindow) {
      let splitLine = studyFrame.width*0.5
      return splitLine
    }
    if (rightMode) {
      let splitLine = readerFrame.x+readerFrame.width
      return splitLine
    }else{
      let splitLine = readerFrame.x
      return splitLine
    }
  }

function undoGroupingWithRefresh(notebookid,f){
  UndoManager.sharedInstance().undoGrouping(
    String(Date.now()),
    notebookid,
    f
  )
  Application.sharedInstance().refreshAfterDBChanged(notebookid)
}

function undoGrouping(notebookid,f){
  UndoManager.sharedInstance().undoGrouping(
    String(Date.now()),
    notebookid,
    f
  )
}

function getWebJS(id) {
  switch (id) {
    case "updateDeeplOffset":
      return `document.getElementsByClassName("dl_header")[0].style.display="none";
        document.getElementsByClassName("lmt__docTrans-tab-container")[0].style.display="none";
        document.getElementsByClassName("lmt__sides_container")[0].style.margin = 0;
        document.querySelector("#dl_translator").style.cssText = "padding-top: 20px";
        document.getElementsByClassName("lmt__language_container")[0].style.display = "none";
        document.getElementsByClassName("lmt__language_container")[1].style.display = "none";
        document.getElementsByClassName("lmt__target_toolbar")[0].style.display = "none";
        document.querySelector("#dl_cookieBanner").style.display="none";
        document.querySelector("#lmt_quotes_article").style.display="none";
        document.querySelector("#lmt__dict").style.margin = 0;
        document.querySelector("#lmt_pro_ad_container").style.display = "none";
        document.querySelector("body > div.dl_footerV2_container").style.display = "none";`
    case "updateThesaurusOffset":
      return `document.getElementsByTagName("header")[0].style.display = "none"
        document.getElementsByTagName("section")[0].style.display = "none"
        document.getElementsByTagName("section")[6].style.display = "none"
        document.getElementsByTagName("section")[7].style.display = "none"
        document.getElementsByTagName("section")[8].style.display = "none"
        document.getElementsByTagName("section")[9].style.display = "none"
        document.getElementsByTagName("p")[5].style.display = "none"
        document.getElementsByClassName("acw ac-widget-placeholder ac-reset")[0].style.display = "none"`
    case "updateBilibiliOffset":
      return `
      document.getElementsByClassName("v-popover-wrap")[0].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[1].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[2].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[3].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[4].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[5].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[6].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[8].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[10].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[11].style.display = "none";
      document.getElementsByClassName("v-popover-wrap")[13].style.display = "none";
      document.getElementsByClassName("recommended-swipe grid-anchor")[0].style.display = "none";
      `
    default:
      return ""
  }
}

function hexColorAlpha(hex,alpha=1.0) {

  if (!hex) {
    // showHUD("undefi")
    let color = UIColor.whiteColor()
    return color.colorWithAlphaComponent(alpha)
  }
  let color = UIColor.colorWithHexString(hex)
  return color.colorWithAlphaComponent(alpha)
}

function genFrame(x,y,width,height) {
  return {x:x,y:y,width:width,height:height}
}

function getOrderText(order) {
  if (order[0] == 4) {
    return 'Order: (Title) + (Excerpt → Comment)'
  }
  let orderNumber = `${order[0]}${order[1]}${order[2]}`
  switch (orderNumber) {
    case "123":
      return 'Order: Title → Excerpt → Comment'
    case "132":
      return 'Order: Title → Comment → Excerpt'
    case "213":
      return 'Order: Excerpt → Title → Comment'
    case "231":
      return 'Order: Excerpt → Comment → Title'
    case "312":
      return 'Order: Comment → Title → Excerpt'
    case "321":
      return 'Order: Comment → Excerpt → Title'
    default:
      return "123";
  }
}

function shouldPrevent(currentURL,requestURL,type) {
  let firstCheck = Application.sharedInstance().osType === 0 && (type===0 || /^https:\/\/m.inftab.com/.test(currentURL))
  if (firstCheck) {
    let blacklist = ["^https?://www.bilibili.com","^https?://m.bilibili.com","^https?://space.bilibili.com","^https?://t.bilibili.com","^https?://www.wolai.com","^https?://flowus.com","^https?://www.notion.so"]
    if (blacklist.some(url=>RegExp(url).test(requestURL))) {
      return true
    }
  }
  return false
}

function showHUD(message,duration=2) {
  let focusWindow = Application.sharedInstance().focusWindow
  Application.sharedInstance().showHUD(message,focusWindow,duration)
}


function postNotification(name,userInfo) {
  let focusWindow = Application.sharedInstance().focusWindow
  NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo(name, focusWindow, userInfo)
  
}

function getNoteById(noteid) {
  let note = Database.sharedInstance().getNoteById(noteid)
  return note
}

function getImage(path,scale=2) {
  return UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(path), scale)
}

function setLocalDataByKey(value,key) {
  NSUserDefaults.standardUserDefaults().setObjectForKey(value,key)
  NSUserDefaults.standardUserDefaults().synchronize()
}

function getLocalDataByKey(key) {
  return NSUserDefaults.standardUserDefaults().objectForKey(key)
}

function getLocalDataByKeyDefault(key,defaultValue) {
  let value = NSUserDefaults.standardUserDefaults().objectForKey(key)
  if (value === undefined) {
    NSUserDefaults.standardUserDefaults().setObjectForKey(defaultValue,key)
    return defaultValue
  }
  return value
}

function addObserver(object,target,notification) {
  NSNotificationCenter.defaultCenter().addObserverSelectorName(object, target, notification);
}
function removeObservers(object,notifications) {
  notifications.forEach(notification=>{
    NSNotificationCenter.defaultCenter().removeObserverName(object, notification);
  })
}

function getPopoverAndPresent(sender,commandTable,width=100) {
  var menuController = MenuController.new();
  menuController.commandTable = commandTable
  menuController.rowHeight = 35;
  menuController.preferredContentSize = {
    width: width,
    height: menuController.rowHeight * menuController.commandTable.length
  };
  var popoverController = new UIPopoverController(menuController);
  let focusWindow = Application.sharedInstance().focusWindow
  var studyController = Application.sharedInstance().studyController(focusWindow);
  var r = sender.convertRectToView(sender.bounds,studyController.view);
  popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  return popoverController
}

function calcDistance(vec1,vec2) {
  let dis = 0
  for (let i = 0; i < 1024; i++) {
    dis = dis+Math.pow((vec1[i]-vec2[i]),2)
  }
  return Math.sqrt(dis)
} 

function getMindmapNodes() {
  let focusWindow = Application.sharedInstance().focusWindow
  return Application.sharedInstance().studyController(focusWindow).notebookController.mindmapView.mindmapNodes;
}

function getSelectedNotes() {
  let focusWindow = Application.sharedInstance().focusWindow
  return Application.sharedInstance().studyController(focusWindow).notebookController.mindmapView.selViewLst.map(item=>item.note.note);
}

function getNotebookNotes(notebookid) {
  let notebook = Database.sharedInstance().getNotebookById(notebookid)
  return notebook.notes
  // let focusWindow = Application.sharedInstance().focusWindow
  // return Application.sharedInstance().studyController(focusWindow).notebookController.mindmapView.mindmapNodes;
}

function getNotebookFlashCards(notebookid) {
  let notebook = Database.sharedInstance().getNotebookById(notebookid)
  return notebook.notes.filter(note=>Database.sharedInstance().hasFlashcardByNoteId(note.noteId))
  // let focusWindow = Application.sharedInstance().focusWindow
  // return Application.sharedInstance().studyController(focusWindow).notebookController.mindmapView.mindmapNodes;
}

function vectorFormatter(vector) {
  let formatted = vector.map(vec=>{
    if (vec.doubleValue) {
      return Number(vec.doubleValue().toFixed(2))
    }else{
      return Number(vec.toFixed(2))
    }
  })
  return formatted
}

/**
 * 在数据来源控制为两位小数即可，其他地方不需要再调用vectorFormatter，会明显降低速度
 * @param {String} apikey
 * @param {String} text
 * @returns {Promise<number[]>}
 */
async function getVec(apikey,text) {
  let final_sign = getAuthorization(apikey)
  let vector = await fetchEmbedding(final_sign,text)
  if (!vector) {
    showHUD("error")
    return undefined
  }
  let nums = vectorFormatter(vector)
  return nums
}


function hasVec(note) {
  let comments = note.comments.filter(comment=>comment.type == "HtmlNote" && /^vector:\/\//.test(comment.text))
  if (comments.length) {
    return true
  }else{
    return false
  }
}

function readVectors(path) {
  if (isfileExists(path)) {
    let vectors = readJSON(path)
    // Object.keys(vectors).map(key=>{
    //     vectors[key] = vectorFormatter(vectors[key])
    // })
    return vectors
    // UIPasteboard.generalPasteboard().string = JSON.stringify(ctr.addonController.vectors)
  }else{
    // showHUD("file not exist")
    return {}
  }
}

function focusNote(note) {
  let focusWindow = Application.sharedInstance().focusWindow
  showHUD(note.noteId)
  return Application.sharedInstance().studyController(focusWindow).focusNoteInMindMapById(note.noteId)
}

function getTextForSearch (note,order) {
    let text
    for (let index = 0; index < order.length; index++) {
      const element = order[index];
      switch (element) {
        case 1:
          if (note.noteTitle && note.noteTitle !== "") {
            text = note.noteTitle
          }
          break;
        case 2:
          if (note.excerptText && note.excerptText !== "" && (!note.excerptPic || note.textFirst)) {
            text = note.excerptText
          }
          break;
        case 3:
          let commentText
          let comment = note.comments.find(comment=>{
            switch (comment.type) {
              case "TextNote":
                if (/^marginnote3app:\/\//.test(comment.text)) {
                  return false
                }else{
                  commentText = comment.text
                  return true
                }
              case "HtmlNote":
                commentText = comment.text
                return true
              case "LinkNote":
                if (comment.q_hpic && !note.textFirst) {
                  return false
                }else{
                  commentText = comment.q_htext
                  return true
                }
              default:
                return false
            }
          })
          // let noteText  = note.comments.filter(comment=>comment.type === "TextNote" && !/^marginnote3app:\/\//.test(comment.text))
          // if (noteText.length) {
          //   text =  noteText[0].text
          // }
          if (commentText && commentText.length) {
            // showHUD("comment")
            text = commentText
          }
          break;
        default:
          break;
      }
      if (text) {
        // showHUD(text)
        return text
      }
    }
  // showHUD("No text found")
  return ""
  }
async function delay(time) {
  return new Promise((resolve, reject) => {
    NSTimer.scheduledTimerWithTimeInterval(time, false, function () {
      resolve()
    })
  })
}

function studyController() {
  let focusWindow = Application.sharedInstance().focusWindow
  return Application.sharedInstance().studyController(focusWindow)
}

function appInstance() {
  return Application.sharedInstance()
}
function readJSON(path) {
  const ret = NSJSONSerialization.JSONObjectWithDataOptions(
    NSData.dataWithContentsOfFile(path),
    1
  )
  if (NSJSONSerialization.isValidJSONObject(ret)) {
    return ret
  } else throw "Invalid JSON"
}

function writeJSON(path, data) {
  NSData.dataWithStringEncoding(
    JSON.stringify(data),
    4
  ).writeToFileAtomically(path, false)
}

function replacer (key, value) {
  if (value.length == 1024) {
    return value.map(val=> Number(val.toFixed(2)))
  }
  return value;
}
// console.log(JSON.stringify(students, replacer, 4))

function saveVectors(path, data) {
  NSData.dataWithStringEncoding(
    JSON.stringify(data),
    4
  ).writeToFileAtomically(path, false)
}
function isfileExists(path) {
  // showHUD(path)
  return NSFileManager.defaultManager().fileExistsAtPath(path)
}
    function preTitle(text) {
      const container = document.createElement("pre");
      container.innerHTML = text;
      return container;
    }
function copy(text) {
  UIPasteboard.generalPasteboard().string = text
}
// function writeTextFile(path, text) {
//   NSData.dataWithStringEncoding("123", 4).writeToFileAtomically(path, false)
// }
//export
// function saveTextFile(
//   content,
//   fileName,
//   UTI = "public.plain-text"
// ) {
//   const path = `${MN.app.tempPath}/${fileName}`
//   writeTextFile(path, content)
//   saveFile(path, UTI)
// }

// //import
// async function openFile(...uti) {
//   // ["com.adobe.pdf"],
//   return new Promise(resolve => {
//     MN.app.openFileWithUTIs(uti, MN.studyController, (path) => {
//       resolve(path)
//     })
//     resolve(undefined)
//   })
// }